<template>
  <div class="table-page">
    <div class="table-page-content">
      <div class="left-tree">
        <tree-side ref="treeSide" :dataLoading="treeLoading" :default-expand-all="false" :defaultProps="defaultProps"
                   :tabList="['组织路段树']" :treeData="treeData" isDeselect
                   @currentChange="currentChange"></tree-side>
      </div>
      <div class="right-table">
        <div class="full-page bg">
          <div class="search-box">
            <div class="search-box-combination">
              <div class="search-box-label">投诉时间：</div>
              <div>
                <el-date-picker
                  v-model="params.querys[5].value"
                  end-placeholder="投诉时间"
                  range-separator="至"
                  start-placeholder="投诉时间"
                  style="width: 280px"
                  type="datetimerange"
                  value-format="yyyy-MM-dd HH:mm:ss"
                  @change="datePickerChange"
                >
                </el-date-picker>
              </div>
              <SearchCommon :optionList="optionList" @search="handleSearch" />
            </div>
          </div>
          <div class="main-table-container">
            <div class="table-container" style="padding: 20px">
              <div ref="btnPanel" class="btn-box">
                <el-button :disabled="!isAddShow" class="btn btn-plus" icon="el-icon-plus" size="small"
                           type="primary" @click="changePage('EditAddPage', { catalogId: treeItem.id })">
                  添加
                </el-button>
                <el-button :disabled="!currentDataDel.length" class="btn btn-delete" icon="el-icon-delete" plain
                           size="small" type="danger" @click="handleDelete()">
                  删除
                </el-button>
              </div>
              <div ref="tableRef" class="table-content">
                <el-table ref="multipleSelection"
                          v-loading="tableLoading"
                          :data="tableData"
                          :default-sort="{ prop: 'complaintTime', order: 'descending' }"
                          :max-height="tableMaxHeight" border class="table-list"
                          element-loading-background="rgba(10 ,38 ,61, 0.9)" row-key="id" stripe
                          @select="handleSelection"
                          @selection-change="handleSelectionChange" @row-dblclick="handleDbClick">
                  <el-table-column align="center" type="selection" width="55" />
                  <el-table-column align="center" label="序号" type="index" width="60" />
                  <el-table-column :formatter="({ roadName }) => roadName || '-'" align="center" label="投诉路段"
                                   min-width="80" prop="roadName" show-overflow-tooltip />
                  <el-table-column
                    :formatter="({ complaintSource }) => dictionaryEscape('yxjc-tsly', complaintSource + '')"
                    align="center" label="投诉来源" min-width="80"
                    prop="complaintSource"
                    show-overflow-tooltip />
                  <el-table-column
                    :formatter="({ specificSource }) => dictionaryEscape('yxjc-jtly', specificSource + '')"
                    align="center" label="具体来源" min-width="80"
                    prop="specificSource"
                    show-overflow-tooltip />
                  <el-table-column
                    :formatter="({ complaintCategory }) => dictionaryEscape('yxjc-tslb', complaintCategory + '')"
                    align="center" label="投诉类别" min-width="80"
                    prop="complaintCategory"
                    show-overflow-tooltip />
                  <el-table-column
                    :formatter="({ complaintObject }) => dictionaryEscape('yxjc-tsdx', complaintObject + '')"
                    align="center" label="投诉对象" min-width="80"
                    prop="complaintObject"
                    show-overflow-tooltip />
                  <el-table-column align="center" label="投诉人姓名" min-width="80" prop="complainantName"
                                   show-overflow-tooltip />
                  <el-table-column align="center" label="投诉人联系方式" min-width="80"
                                   prop="complainantContactInformation"
                                   show-overflow-tooltip />
                  <el-table-column :formatter="({ complaintTime }) => complaintTime || '-'" align="center"
                                   label="投诉时间"
                                   min-width="80"
                                   prop="complaintTime" show-overflow-tooltip sortable />
                  <el-table-column align="center" label="操作" min-width="80" show-overflow-tooltip>
                    <template v-slot="{ row }">
                      <el-link :underline="false" type="primary" @click="handleDetailPage(row)">
                        详情
                      </el-link>
                      <el-link :underline="false" type="danger" @click="handleDelete(row)">
                        删除
                      </el-link>
                    </template>
                  </el-table-column>
                </el-table>
                <pagination ref="paginationPanel" :pageResult="params.pageBean" style="margin-top: 10px"
                            @size-change="handleSizeChange" @current-change="handleCurrentChange" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import pagination from '@/components/SuperPagination/index.vue'
import {TableMixin} from '@/mixins/tableMixin'
import treeSide from '@/components/treeSide/index.vue'
import SearchCommon from '@/components/SearchCommon/index.vue'
import {
  complaintTemplateDownload,
  tableData,
  tableDelete
} from '@/api/patrolAndRescue/operationalMonitoring/complaintLedgerManagement'
import PubSub from 'pubsub-js'
import {dictionaryEscape, getDictionaryByCode} from '@/utils/dictionary'
import {mapState} from 'vuex'
import moment from 'moment'
import {getTree} from '@/api/tree'

export default {
  name: 'TablePage',
  components: {
    pagination,
    treeSide,
    SearchCommon
  },
  mixins: [TableMixin],
  computed: {
    action: () => `${window.context.portal}/monitor/bizEarlyWarningManagement/v1/importData`,
    ...mapState({
      headers: (state) => ({Authorization: `Bearer ${state.login.currentUser.token}`})
    })
  },
  data() {
    return {
      isAddShow: false,
      pubSub: null,
      tableMaxHeight: '600px',
      loading: false,
      treeLoading: true,
      tableLoading: false,
      treeData: [], //左边树
      defaultProps: {
        children: 'children',
        label: 'name'
      },
      tableData: [],
      currentDataDel: [],
      optionList: [
        // {title: '投诉路段', prop: 'roadName', type: 'input', default: true},
        {
          title: '投诉类别',
          prop: 'complaintCategory',
          type: 'select',
          option: getDictionaryByCode('yxjc-tslb'),
          multiple: true,
          default: true
        },
        {
          title: '投诉来源',
          prop: 'complaintSource',
          type: 'select',
          option: getDictionaryByCode('yxjc-tsly'),
          multiple: true
        },
        {
          title: '具体来源',
          prop: 'specificSource',
          type: 'select',
          option: getDictionaryByCode('yxjc-jtly'),
          multiple: true
        },
        {
          title: '投诉对象',
          prop: 'complaintObject',
          type: 'select',
          option: getDictionaryByCode('yxjc-tsdx'),
          multiple: true
        }
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'IN', property: 'roadId'},
          // {group: 'quick', operation: 'LIKE', relation: 'OR', property: 'roadName'},
          {group: 'quick', operation: 'IN', relation: 'AND', property: 'complaintCategory'},
          {group: 'quick', operation: 'IN', relation: 'AND', property: 'complaintSource'},
          {group: 'quick', operation: 'IN', relation: 'AND', property: 'specificSource'},
          {group: 'quick', operation: 'IN', relation: 'AND', property: 'complaintObject'},
          {
            operation: 'BETWEEN',
            property: 'complaint_time_',
            value: [
              moment().subtract(1, 'month')
                .startOf('month')
                .format('YYYY-MM-DD HH:mm:ss'),
              moment()
                .endOf('month')
                .format('YYYY-MM-DD HH:mm:ss')
            ]
          }
        ],
        sorter: []
      },
      treeDialog: false, // 科目信息弹层
      treeItemId: '', // 树形目录id
      treeItem: {}, // 树形节点选中对象
      btnLoading: false
    }
  },
  created() {
    // 获取树形目录-
    this.getOrgTreeData(treeData => {
      // 回调中默认选中第一项并将其id作为参数请求表格
      this.treeItem = treeData[0] || {}
      let array = []
      if (this.treeItem.children.length > 0) {
        array = this.extractIds(this.treeItem)
      }
      this.$nextTick(_ => {
        this.$refs.treeSide?.setCurrentKey(treeData[0]?.id)//通过 $refs 获取treeSide组件引用，并调用 setCurrentKey方法设置当前选中的树节点。
        this.$refs.treeSide?.expandHandle(true, 2)
      })
      setQueryValue(this.params, 'roadId', array)
      this.loadData() //加载表格数据
    })
  },
  mounted() {
    this.pubSub = PubSub.subscribe('TablePage', (_, data) => {
      switch (data.type) {
        case 'add':
          this.params.pageBean.page = 1
          this.loadData()
          break
        case 'edit':
          this.loadData()
          break
      }
    })

  },
  methods: {
    dictionaryEscape,
    extractIds(node) {
      let ids = []
      // 如果当前节点有 children，则递归提取
      if (node.children) {
        ids = node.children.map(child => child.id) // 提取当前节点的 id
        // 递归提取子节点的 id
        node.children.forEach(child => {
          ids = ids.concat(this.extractIds(child))
        })
      }
      return ids
    },
    // 时间范围切换
    datePickerChange(val) {
      setQueryValue(this.params, 'complaint_time_', val)
      this.params.pageBean.page = 1
      this.loadData()
    },
    // 获取公司树-异步方法，用于从后端获取树形数据
    async getOrgTreeData(callback) {
      try {
        this.treeLoading = true   //开始加载时显示加载状态
        let {value} = await getTree()  // 调用 API 获取树形数据
        this.treeData = [value]
      } finally {
        this.treeLoading = false// 无论成功或失败，都关闭加载状态
        callback && callback(this.treeData)// 如果提供了回调函数，则调用它并传入树形数据
      }
    },
    transformTreeData(data) {
      return {
        name: data.name,
        id: data.id,
        children: data.children.reduce((acc, child) => {
          acc.push({
            id: child.id,
            name: child.name,
            path: child.path,
            children: child.roadList.map(road => ({
              id: road.id,
              name: road.name,
              path: road.path
            }))
          })
          return acc
        }, [])
      }
    },
    //左边树节点
    currentChange(nodeItem) {
      if (nodeItem.id === '1766017468444450816') {
        this.isAddShow = false
        setQueryValue(this.params, 'roadId ', this.extractIds(nodeItem))
      } else if (nodeItem.children && nodeItem.children.length > 0) {
        this.isAddShow = false
        const array = nodeItem.children.map(item => item.id)
        setQueryValue(this.params, 'roadId ', array)
      } else {
        this.isAddShow = true
        setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      }

      // 判断是否是一级目录（有 children 属性）
      // if (nodeItem.children && nodeItem.children.length > 0) {
      //   this.isAddShow = false
      //   const array = nodeItem.children.map(item => item.id)
      //   setQueryValue(this.params, 'roadId ', array)
      // } else {
      //   this.isAddShow = true
      //   setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      // }
      // setQueryValue(this.params, 'roadId', nodeItem?.id || '')
      this.treeItem = nodeItem || {}
      this.calcTableHeight(500)
      PubSub.publish('TreeItemSelected', {
        id: nodeItem?.id || '',
        name: nodeItem?.name || '',
        path: nodeItem?.path || ''
      })
      this.params.pageBean.page = 1
      this.loadData()
    },
    //获取数据
    async loadData() {
      this.tableLoading = true
      const {total = 0, rows = []} = await tableData(refineRequestBody(this.params))
      this.params.pageBean.total = total
      this.tableData = rows.map(row => ({
        ...row,
        roadName: row.roadName || this.treeItem.name
      }))
      this.tableLoading = false
    },

    // 删除
    handleDelete(row) {
      this.clickTimer = true
      this.$confirm('确定删除选中投诉台账吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        let ids = row ? row.id : this.currentDataDel.join()
        let {state, message} = await tableDelete(ids)
        if (state) {
          this.$message.success(`删除成功`)
          const {page, pageSize, total} = this.params.pageBean
          const totalPages = Math.ceil(total / pageSize) // 计算总页数
          if (totalPages > 1 && page === totalPages) {
            if (this.tableData.length === 1) { // 当前页只有一条数据
              this.params.pageBean.page -= 1 // 返回前一页
            }
          }
          await this.loadData()
        } else {
          this.$message.error(message)
        }
      }).catch(_ => _)
    },

    //修改
    handleDbClick(row) {
      if (this.clickTimer) return (this.clickTimer = false)
      const payload = {
        ...row,
        roadName: row.roadName || this.treeItem.name
      }
      this.changePage('EditAddPage', payload)
    },

    // 模块下载
    async templateDownload() {
      this.btnLoading = true
      try {
        await complaintTemplateDownload()
      } finally {
        this.btnLoading = false
      }
    },
    // 导出数据
    async exportData() {
      this.btnLoading = true
      try {
        // await exportFile({ ...this.searchFrom, deptId: this.treeNode.id });
        // this.$message.success(`数据导出成功`);
      } finally {
        this.btnLoading = false
      }
    },

    //  导入文件上传前
    beforeUpload(file) {
      return new Promise((resolve, reject) => {
        this.uploadLoading = this.$loading({
          lock: true,
          text: '导入文件中',
          spinner: 'el-icon-loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })
        const {size, name} = file
        this.$confirm(`请确认是否上传 “${name}” 为附件？`, '提示', {
          confirmButtonText: '确认',
          cancelButtonText: '取消',
          type: 'warning'
        })
          .then(_ => {
            const maxSize = 500 * 1024 * 1024 // 500MB
            const typeRegular = /\.(xls|xlsx)$/i
            const verification = [
              {
                condition: !typeRegular.test(name),
                result: () => this.$message.error('只能上传xls或xlsx文件类型')
              }
              // {
              //   condition: size > maxSize,
              //   result: () => this.$message.warning("附件大小不能超过500MB"),
              // },
            ]
            // 是否通过验证
            const passedOrNot = !verification.some(item => {
              if (item.condition) {
                this.uploadLoading?.close()
                setTimeout(() => item.result(), 0)
              }
              return item.condition
            })
            passedOrNot ? resolve() : reject()
          })
          .catch(_ => {
            reject()
            this.uploadLoading?.close()
          })
      })
    },

    // 导入文件上传成功
    async handleSuccess(res = {}) {
      const {code = 200} = res
      if (code === 200) {
        this.search()
        this.$message.success(`文件上传成功`)
      } else {
        this.$message.error('文件上传失败，请重试..')
      }
      this.uploadLoading?.close()
    },

    // 导入文件上传失败
    handleError() {
      this.$message.error('文件上传失败，请重试..')
      this.uploadLoading?.close()
    },

    // 改变页面
    changePage(pageName = '', row = {}) {
      if (!pageName) return
      const payload = row.id ? row : {
        catalogId: this.treeItem.id,
        roadName: this.treeItem.name,
        path: this.treeItem.path
      }
      this.$emit('changePage', pageName, _ => {
        PubSub.publish(pageName, payload)
      }, row.id ? '编辑' : '添加')
    }
  },
  beforeDestroy() {
    // 在组件销毁之前 清除订阅消息
    PubSub.unsubscribe(this.pubSub)
  }
}
</script>

<style lang="scss" scoped></style>
